module Network.Loshadka.Jar where

import Prelude hiding (readFile)
import System.Directory (getDirectoryContents)
import Data.ByteString.Lazy.Char8 (ByteString, readFile)
import Data.List (isSuffixOf)

findJar :: String -> IO String
findJar path = do
  dir <- getDirectoryContents path
  return $ head $ filter (\x -> ".jar" `isSuffixOf` x) dir

readJar :: String -> IO ByteString
readJar path = do
  jar <- findJar path
  readFile jar
